(function () { // 即時実行関数（グローバル汚染対策）
  const browserType = document.querySelector('html').dataset.browseMode;
  // DOM・画像含め読み込み後の処理の実行
  jQuery(window).on('load', function() {
    // メニュー
    menuFnc();
    
    // ランダム表示
    randomizeAndDuplicate('.js-list-random');

    // タブ切り替え
    initializeTabSwitchFnc('.functions-area .js-radio-select > li', '.functions-area .js-radio-contents > li');
    
    functionSlickSlider('.js-slider-hairezo');
    functionSlickSlider('.js-slider-liveGnd');
    functionSlickSlider('.js-slider-tori-aiSubject');
    functionSlickSlider('.js-slider-tori-highSpeed');
    

    // デバイス幅判定
    if (browserType === 'S') {
      // スマホ処理
    } else {
      // PC処理
      accessorySlickSlider('.js-accessory-slide');
    }
    
    // 高さ揃え
    equalizeHeights('.accessory--list-item .item-text-contents .item-name');
    equalizeHeights('.accessory--list-item .item-text-contents .text');
  });


  jQuery(window).resize(function(){

    equalizeHeights('.accessory--list-item .item-text-contents .item-name');
    equalizeHeights('.accessory--list-item .item-text-contents .text');

  });

  // スクロールイベントの実行
  jQuery(window).scroll(function () {

  });

  // メニューを開く処理
  function menuFnc() {
    let targetElement = jQuery('.menu');
    // 通常メニューを開くの処理
    jQuery(document).on('click', '.js-menu', function () {
      if (targetElement.hasClass('is-open') === false) {
        jQuery('.menu--contents').fadeIn('fast');
        targetElement.addClass('is-open');
        jQuery('.menu-openButtonText').text('CLOSE')
      } else {
        targetElement.removeClass().addClass('menu');
        jQuery('.menu--contents').fadeOut('fast');
        jQuery('.menu-openButtonText').text('MENU')
      }
      return false;
    });
    // メニュー内のリンククリック
    jQuery('.menu--contents-link-list a').click(function() {
      // .js-menuをクリックしたことにする
      jQuery('.js-menu').click();
    });
  }

  //--- ギャラリーのランダム表示
  function randomizeAndDuplicate(selector) {
    // ul要素を取得
    let ul = jQuery(selector).children('ul');
  
    // li要素を取得し、シャッフル
    let listItems = ul.children('.gallery--list-item').get().sort(function() {
      return Math.random() - 0.5;
    });
    // シャッフルした結果をulに追加
    ul.empty().append(listItems);
    ul.clone().appendTo('.gallery--list-contents');

    jQuery('.gallery--list-contents').addClass('active');

    // jQuery(selector).slick({
    //   autoplay: true,
    //   autoplaySpeed: 0, 
    //   speed: 18000, // スライドが流れる速度
    //   cssEase: "linear",
    //   // slidesToShow: 3, 
    //   swipe: false, 
    //   arrows: false, 
    //   pauseOnFocus: false,
    //   pauseOnHover: false,
    //   variableWidth: true
    // });
  }

  //--- タブ切り替え
  function initializeTabSwitchFnc(tabSelector, contentSelector) {
    let tab = jQuery(tabSelector);
    let contents = jQuery(contentSelector);

    jQuery(tab).on('click', function() {
      jQuery(tab).removeClass('active');
      jQuery(contents).removeClass('active');

      jQuery(this).addClass('active');
      let index = jQuery(this).index();
      jQuery(contents).eq(index).addClass('active');
    });
  }

  //--- 機能のスライダー
  function functionSlickSlider(selector) {
    jQuery(selector).slick({
      slidesToShow: 1,
      slidesToScroll: 1,
      autoplay: false,
      adaptiveHeight: true,
      touchMove: false,
      dots: true,
      arrows: true
    });
  }

  //--- レンズ・アクセサリーのスライダー
  function accessorySlickSlider(selector) {
    jQuery(selector).slick({
      slidesToShow: 4,
      slidesToScroll: 1,
      autoplay: false,
      dots: true,
      arrows: true
    });
    
    // レンズ・アクセサリーのコンテンツ内高さ揃え初回実行
    equalizeHeights('.accessory--list-item .item-text-contents .item-name');
    equalizeHeights('.accessory--list-item .item-text-contents .text');
  }

  //--- 高さを揃える関数
  function equalizeHeights(selector) {
    var maxHeight = 0;
    jQuery(selector).each(function(){
      var elementHeight = jQuery(this).height();
      if (elementHeight > maxHeight) {
        maxHeight = elementHeight;
      }
    });
    jQuery(selector).css("height", maxHeight + "px");
  }
  

  const targets = document.querySelectorAll('.parallax-inner');
  const options = {
    root: null,
    rootMargin: '0px',
    threshold: 0.25
  };
  const observer = new IntersectionObserver(intersect, options);
  setTimeout(() => {
    targets.forEach(target => {
      observer.observe(target);
    });
  }, 1500);
  
  function intersect(entries) {
    entries.forEach(entry => {
      if (entry.isIntersecting) {
        entry.target.classList.add('is-inview');
      }
    });
  }
    
}());